#include <GL/glut.h>
#include <math.h>
#include <stdio.h>      // Header file for standard file i/o.
#include <stdlib.h>     // Header file for malloc/free.
#include "utils.c"
#include <string.h>

const int chekor=17;
const int chekor2=17;
float agolX=0;
float agolY=0;
float agolZ=0;
float transZ=10;
float rotateA=60;
float rotateAspeed=0.0f;
float shadowTransparency=0.5f;
int polygonMode=GL_FILL;
int soba_vidliva=GL_TRUE;

float svX=0, svY=0, svZ=10;


GLubyte space[] =
{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

GLubyte letters[][13] = {
{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0x66, 0x3c, 0x18},
{0x00, 0x00, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe},
{0x00, 0x00, 0x7e, 0xe7, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e},
{0x00, 0x00, 0xfc, 0xce, 0xc7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc7, 0xce, 0xfc},
{0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xc0, 0xff},
{0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xff},
{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xcf, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e},
{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3},
{0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7e},
{0x00, 0x00, 0x7c, 0xee, 0xc6, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06},
{0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xe0, 0xf0, 0xd8, 0xcc, 0xc6, 0xc3},
{0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0},
{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xdb, 0xff, 0xff, 0xe7, 0xc3},
{0x00, 0x00, 0xc7, 0xc7, 0xcf, 0xcf, 0xdf, 0xdb, 0xfb, 0xf3, 0xf3, 0xe3, 0xe3},
{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e},
{0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe},
{0x00, 0x00, 0x3f, 0x6e, 0xdf, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0x66, 0x3c},
{0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe},
{0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0x7e, 0xe0, 0xc0, 0xc0, 0xe7, 0x7e},
{0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xff},
{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3},
{0x00, 0x00, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3},
{0x00, 0x00, 0xc3, 0xe7, 0xff, 0xff, 0xdb, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3},
{0x00, 0x00, 0xc3, 0x66, 0x66, 0x3c, 0x3c, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3},
{0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3},
{0x00, 0x00, 0xff, 0xc0, 0xc0, 0x60, 0x30, 0x7e, 0x0c, 0x06, 0x03, 0x03, 0xff}
};

GLuint fontOffset;

void makeRasterFont(void)
{
   GLuint i, j;
   glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

   fontOffset = glGenLists (128);
   for (i = 0,j = 'A'; i < 26; i++,j++) {

      glNewList(fontOffset + j, GL_COMPILE);
      glBitmap(8, 13, 0.0, 2.0, 10.0, 0.0, letters[i]);
      glEndList();
   }
   glNewList(fontOffset + ' ', GL_COMPILE);
   glBitmap(8, 13, 0.0, 2.0, 10.0, 0.0, space);
   glEndList();
}

void printString(char *s)
{
   glPushAttrib (GL_LIST_BIT);
   glListBase(fontOffset);
   glCallLists(strlen(s), GL_UNSIGNED_BYTE, (GLubyte *) s);
   glPopAttrib ();
}


void kocka (void) // ova e objektot koj go pretstavuva svetloto
{
   int i, j;

   glColorMaterial(GL_FRONT_AND_BACK, GL_DIFFUSE);
   glFrontFace(GL_CW);

   glColor3f(1,1,1);
   glBegin(GL_QUADS);
      glNormal3f(0,0,1);
      glVertex3f(-10,-10,0);
      glVertex3f(10,-10,0);
      glVertex3f(10,10,0);
      glVertex3f(-10,10,0);

      glNormal3f(0,0,-1);
      glVertex3f(-10,-10,13);
      glVertex3f(-10,10,13);
      glVertex3f(10,10,13);
      glVertex3f(10,-10,13);

      glNormal3f(0,1,0);
      glVertex3f(-10,-10,0);
      glVertex3f(-10,-10,13);
      glVertex3f(10,-10,13);
      glVertex3f(10,-10,0);

      glNormal3f(-1,0,0);
      glVertex3f(10,10,0);
      glVertex3f(10,-10,0);
      glVertex3f(10,-10,13);
      glVertex3f(10,10,13);

      glNormal3f(0,-1,0);
      glVertex3f(10,10,0);
      glVertex3f(10,10,13);
      glVertex3f(-10,10,13);
      glVertex3f(-10,10,0);

      glNormal3f(1,0,0);
      glVertex3f(-10,10,0);
      glVertex3f(-10,10,13);
      glVertex3f(-10,-10,13);
      glVertex3f(-10,-10,0);
   glEnd();
   glFrontFace(GL_CCW);
}

void mrezha10x10 (void) {
   glBegin(GL_QUADS);
      glNormal3f(0,1,0); // edna zaednichka normala za site chetiriagolnici od mrezhata
      int i=0;
      int j=0;
      for ( i=0; i<10; i++) {
        for ( j=0; j<10; j++) {
          glVertex3f(i,  0,j);
          glVertex3f(i+1,0,j);
          glVertex3f(i+1,0,j+1);
          glVertex3f(i,  0,j+1);
        }
      }
   glEnd();
}

void soba (void) {
   int i, j;

   float mat_ambient []={0.05f, 	0.05f, 	0.05f,   1};
   float mat_diffuse []={0.5f, 	0.5f, 	0.5f,  1};
   float mat_specular[]={0.7f, 	0.7f, 	0.7f, 1};
   float mat_shininess = 0.078125f *128;
   glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);
   glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_diffuse);
   glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, mat_specular);
   glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat_shininess);

   glMatrixMode(GL_MODELVIEW);

   glBegin(GL_QUADS);
      // patos
      glNormal3f(0,0,1); // normalite vo sobata treba da se kon vnatre

      for (i=-10; i<10; i++) {
        for (j=-10; j<10; j++) {
          glTexCoord2f(0, 0); glVertex3f(i,j,0);
          glTexCoord2f(0.25, 0); glVertex3f(i+1,j,0);
          glTexCoord2f(0.25, 0.25); glVertex3f(i+1,j+1,0);
          glTexCoord2f(0, 0.25); glVertex3f(i,j+1,0);
        }
      }
   glEnd();

   glMatrixMode(GL_MODELVIEW);

   glBegin(GL_QUADS);      // tavan
      glNormal3f(0,0,-1);
      glVertex3f(-10,-10,13);
      glVertex3f(-10,10,13);
      glVertex3f(10,10,13);
      glVertex3f(10,-10,13);
   glEnd();


   glBegin(GL_QUADS);      // zid 1
      glNormal3f(0,1,0);
      glVertex3f(-10,-10,13);
      glVertex3f(10,-10,13);
      glVertex3f(10,-10,0);
      glVertex3f(10,-10,0);
   glEnd();

   glColor3f(1,0.2,0);
   glPushMatrix();
      glTranslatef(10,-10,0);
      glScalef(-2,2,1.3);
      glRotatef(90,0,0,1);
      mrezha10x10();
   glPopMatrix();

   glColor3f(1,0.2,0);
   glPushMatrix();
      glTranslatef(-10,10,0);
      glScalef(2,-2,1.3);
      mrezha10x10();
   glPopMatrix();

   glColor3f(1,0.2,0);
   glPushMatrix();
      glTranslatef(-10,-10,0);
      glScalef(-2,2,1.3);
      glRotatef(90,0,0,1);
      mrezha10x10();
   glPopMatrix();
}

void displayRender() {
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   glFrustum(-1, 1, -1, 1, 1, 50);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   gluLookAt(0,transZ,10,0,3,0,0,1,0);

   glPolygonMode(GL_FRONT_AND_BACK,polygonMode);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   glEnable(GL_LIGHTING);

   glRotatef(-90,1,0,0);
   glRotatef(rotateA,0,0,1);

   // crtanje scena
   GLfloat svetlo0_position[]= {svX,svY,svZ,1};
   glLightfv(GL_LIGHT0,GL_POSITION,svetlo0_position);

   glMatrixMode(GL_MODELVIEW);
   // crtanje na scenata
   glPushMatrix();
     glTranslatef(svX,svY,svZ);
     glScalef(0.03,0.03,0.03);
     kocka();
   glPopMatrix();

   glDisable(GL_LIGHTING);
   glColor3f(1,1,1);
   glRasterPos3f(5, 5,5);
   printString("THE QUICK BROWN FOX JUMPS");
   glRasterPos3f(0, 2,0);
   printString("OVER A LAZY DOG");
   glEnable(GL_LIGHTING);

   if (soba_vidliva) {
     soba();
  }

}

void display (void) {
// Display any recent error messages
   displayRender ();
   GLenum glError;
   int i = 0;
   do {
     glError = glGetError();
	 if (glError!=GL_NO_ERROR) printf("%s \n", gluErrorString(glError));
     i++;
	 }
   while(i<6 && glError != GL_NO_ERROR);
   glFlush();
   glutSwapBuffers();
}

void init (void) {
   glShadeModel (GL_SMOOTH);

   glClearColor(0.3f, 0.3f, 0.3f, 1.0f);

   glEnable(GL_DEPTH_TEST);
   glEnable(GL_LIGHTING);
   glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

   // postavuvanje svetlo
   GLfloat global_ambient[]= {0.3,0.3,0.3,1};
   glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
   glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
   glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);

   // Svetlo 1
   GLfloat diffuse[] = { 0.6f, 0.6f, 0.6f, 1.0f};
   GLfloat specular[] = { 0.9f, 0.9f, 0.9f, 1.0f};
   GLfloat ambient[] = { 0.3f, 0.3f, 0.3f, 1.0f};
   GLfloat spotDir[] = { 0.0f, 0.0f, 1.0f };
   glLightfv(GL_LIGHT0,GL_AMBIENT,ambient);
   glLightfv(GL_LIGHT0,GL_DIFFUSE,diffuse);
   glLightfv(GL_LIGHT0,GL_SPECULAR,specular);
   //glLightf(GL_LIGHT0,GL_SPOT_CUTOFF,60.0f); // POTREBNO E ZA SPOT SVETLO
   glLightf(GL_LIGHT0,GL_SPOT_EXPONENT,0.01f);
   glEnable(GL_LIGHT0);

   makeRasterFont();
}


void keyboard(unsigned char key, int x, int y)
{
   printf("%d %f %f %f \n", key, svX, svY, svZ);
   switch (key) {
      case 27:
         exit(0);
         break;
      case 'W':
         transZ+=0.5f;
         if (transZ>13) transZ=13;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'S':
         transZ-=0.5f;
         if (transZ<0) transZ=0;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'w':
         transZ+=0.1f;
         if (transZ>13) transZ=13;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 's':
         transZ-=0.1f;
         if (transZ<0) transZ=0;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'A':
         rotateAspeed+=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'a':
         rotateAspeed+=0.1f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'D':
         rotateAspeed-=1.0f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'd':
         rotateAspeed-=0.1f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '1':
         polygonMode=GL_LINE;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '2':
         polygonMode=GL_FILL;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '3':
         soba_vidliva=!soba_vidliva;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'i':
         svY+=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'k':
         svY-=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'j':
         svX-=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'l':
         svX+=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'y':
         svZ+=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case 'h':
         svZ-=0.2f;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '5':
         shadowTransparency+=0.01f;
         if (shadowTransparency>1) shadowTransparency=1;
         glutPostRedisplay();  // obnovi go prikazot
         break;
      case '6':
         shadowTransparency-=0.01f;
         if (shadowTransparency<0) shadowTransparency=0;
         glutPostRedisplay();  // obnovi go prikazot
         break;
   }
}


void idle(void)
{
  rotateA+=rotateAspeed;
  glutPostRedisplay();
}

int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
   glutInitWindowSize (640, 480);
   glutInitWindowPosition (50, 50);
   glutCreateWindow ("  ");
   printf("VENDOR:         %s \n", glGetString(GL_VENDOR));
   printf("RENDERER:       %s \n", glGetString(GL_RENDERER));
   printf("VERSION:        %s \n", glGetString(GL_VERSION));
   printf("EXTENSIONS:     %s \n", glGetString(GL_EXTENSIONS));
   printf("GLU_VERSION:    %s \n", gluGetString(GLU_VERSION));
   printf("GLU_EXTENSIONS: %s \n", gluGetString(GLU_EXTENSIONS));
   init ();
   glutDisplayFunc(display);
   glutIdleFunc(idle); // ovaa funkcija treba da se povika koga programot ne pravi nishto
   glutKeyboardFunc(keyboard);  // Pri pritisok na tastaturata se povikuva keboard
   glutMainLoop();
   return 0;
}

